<?php

namespace FiloBlu\ExtAmastyGeoipRedirect\Model;

class CountryContinent extends \Magento\Framework\Model\AbstractModel {
    
    protected $_countryContinentCollectionFactory;
    protected $_continentCollectionFactory;
    
    protected $_countryContinentArray;
    protected $_continentArray;
    
    public function __construct(
        \FiloBlu\ExtAmastyGeoipRedirect\Model\ResourceModel\CountryContinent\CollectionFactory $countryContinentCollectionFactory,
        \FiloBlu\ExtAmastyGeoipRedirect\Model\ResourceModel\Continent\CollectionFactory $continentCollectionFactory,
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
        array $data = []
    )
    {
        $this->_countryContinentCollectionFactory = $countryContinentCollectionFactory;
        $this->_continentCollectionFactory = $continentCollectionFactory;
        parent::__construct($context, $registry, $resource, $resourceCollection, $data);
    }
    
     /**
     * Initialize resource model
     *
     * @return void
     */
    protected function _construct() {
        $this->_init('FiloBlu\ExtAmastyGeoipRedirect\Model\ResourceModel\CountryContinent');
    }
    
    public function getContinentByCountry($countryId)
    {
        if (!$this->_countryContinentArray) {
            $countryContinentCollection = $this->_countryContinentCollectionFactory->create();
            $countryContinentCollection->addFieldToSelect(array('continent_id','country_id'));
            foreach ($countryContinentCollection as $countryContinent) {
                $this->_countryContinentArray[$countryContinent->getCountryId()] = $countryContinent->getContinentId();
            }
        }
        
        if (!$this->_continentArray) {
            $continentCollection = $this->_continentCollectionFactory->create();
            $continentCollection->addFieldToSelect('*');
            foreach ($continentCollection as $continent) {
                $this->_continentArray[$continent->getContinentId()] = $continent;
            }
        }
        
        return $this->_continentArray[$this->_countryContinentArray[$countryId]];
    }
    
}
